(in-package :cl-user)
(defpackage myapp.web
  (:use :cl
        :caveman2
        :myapp.config
        :myapp.view
        :myapp.db
        :datafly
        :sxql
        :osicat)
  (:import-from :cl-markdown :markdown)
  (:export :*web*))
(in-package :myapp.web)

;;
;; Application

(defclass <web> (<app>) ())
(defvar *web* (make-instance '<web>))
(clear-routing-rules *web*)





;; 定义使用的数据库

(setf (osicat:environment-variable "APP_ENV") "development")
(config :debug)

     
;; 用来查询文章。

(defun search-post (p-title)
  (with-connection (db)
    (retrieve-all
      (select :post
        (from :myapp)
        (where (:= :title p-title)))
	  :as 'trivial-types:association-list)))


;;
;; Routing rules


(defroute "/" ()
  (with-layout (:title "Welcome to pf-wiki")
    (render #P"index.tmpl")))

(defroute "/write" ()
  (with-layout (:title "write")
    (render #P"write.tmpl")))
    
(defroute "/add-post" (&key (|title| "标题") (|post| "请输入正文"))
  (with-layout (:title "输出文章")
	(with-connection (db)
	  (execute
	   (insert-into :myapp
					(set= :title |title|
						  :post |post|))))
	(format nil "《~A》已经保存  " |title|)))

(defroute "/search" ()
  (with-layout (:title "search")
	(render #P "search.tmpl")))


(defroute "/search-post" (&key (|s-title| "标题"))
  (with-layout (:title |s-title|)
	(format nil	(with-output-to-string (out)
				  (markdown (cdaar (search-post |s-title|)) :stream out)))))


	

;;创建表格

(defun create-myapp-table ()
  (with-connection (db)
    (execute
      (create-table (:myapp :if-not-exists t)
        ((title :type 'string)
         (post :type 'text))))))


;;删除表格

(defun drop-myapp-table ()
  (with-connection (db)
    (execute
      (drop-table :myapp :if-exists t))))

(defroute "/drop-db" ()
  (with-layout (:title "建立数据库")
			   (drop-myapp-table)
			   (format nil "数据库已删除")))

(defroute "/create-db" ()
  (with-layout (:title "初始化数据库")
			   (create-myapp-table)
			   (format nil "数据库已建立")))   

  
;;
;; Error pages

(defmethod on-exception ((app <web>) (code (eql 404)))
  (declare (ignore app))
  (merge-pathnames #P"_errors/404.html"
                   *template-directory*))
